package dacia;

import java.io.*;

/* A Message represents the information exchanged between two PROCs
 * The body of the message can be of any type. The Object type should
 * be refined in subclasses. It can also contain methods to be applied
 * to the data
 */
public class Message implements Serializable {
  public int id = 0;
  /* The PROC that created this message*/
  public int origin = 0;
  /* The data in this message
   */
  Object data = null;
  /* The port where this message has been received
   * Used by the worker thread to determine the port where this message
   * has been received
   */
  int portNo = 0;

  public Object getData() {
    return data;
	}

  public void setData(Object theData) {
    data = theData;
  }

  public int getPort() {
    return portNo;
  }

  public void setPort(int thePort) {
    portNo = thePort;
  }
}
