package dacia;

/* Implements the REPLICATE PROC, having 1 input (port 0) and n output
 * (ports 1-n) ports.
 * Sends the messages received on the input port to all output ports.
 */
public class Replicate extends Proc {
  public Replicate(String procName, int outputNo) {
		super(procName, 1+outputNo);
		type = REPLICATE;
	}

	/* By default, handleMessage() and handleAsyncMessage() should do the same
   * thing, namely write the message synchronously to the output port.
   */
	public void handleMessage(Message msg, int port) {
    if(port != 0)
      System.out.println("Replicate " + id + " : message received on port "
                         + port);
    else
      for(int i=1; i< portNo; i++)
        output(i, msg, 1);
	}

	public void handleAsyncMessage() {
		Message msg = null;

    while(true) {
      if((msg = getMessage()) == null)
        return;
      if(msg.getPort() != 0)
        System.out.println("Replicate " + id + " : message received on port "
                           + port);
      else
        for(int i=1; i< portNo; i++)
          output(i, msg, 1);
    }
	}
}
