package dacia.apps.chat;

import dacia.*;
import java.util.*;

/* Implements the ChatServer PROC, having a variable number of ports
 * (is set in the constructor). Broadcasts the messages received to all
 * the connected ports, excluding the port the message came on.
 */
public class ChatServer extends Proc {
  Hashtable recvdProcs = null;

  public ChatServer() {
    this(5);
  }

  public ChatServer(int nports) {
    super("ChatServer", nports);
    recvdProcs = new Hashtable(20);
  }

  public void handleMessage(Message msg, int portNum) {
    Integer oldID;
    if((oldID = (Integer)recvdProcs.put((new Integer(msg.origin)),
                                        (new Integer(msg.id)))) != null)
      if(msg.id <= oldID.intValue())
        return;
    for(int i=0; i<portNo; i++)
      if((i != portNum) && (port[i].connectionStatus != 0))
        output(i, msg, 0);
  }

	public void handleAsyncMessage() {
		Message msg;
    while(true) {
      if((msg = getMessage()) == null)
        return;
      handleMessage(msg, msg.getPort());
    }
	}

  void sendMessage(String message) {
    Message msg = new Message();
    msg.setData((Object)message);
    output(0, msg, 1);
  }

}



