package dacia.apps.chat;

import dacia.*;
import java.net.*;

public class Main {

  public static void main(String[] args) {
    Proc server, clients[];
    int nClients = 0, i = 0;;

    if(args.length < 1) {
      System.out.println("Usage error: java comp.Main config_file_name <no_clients>");
      System.exit(1);
    }
    Engine.init(args[0]);

    server = new ChatServer(10);
    Engine.addProc(server);

    if(args.length == 2) {
      try{
        nClients = (new Integer(args[1])).intValue();
      }
      catch(NumberFormatException e) {
        System.out.println("Usage error: java comp.Main config_file_name <no_clients>");
        System.exit(2);
      }
      clients = new Proc[nClients];
      for(i=0; i<nClients; i++) {
        //clients[i] = new Forward();
        clients[i] = new Chat();
        Engine.addProc(clients[i]);
        if(i<3)
          Engine.connectProcs(clients[i], 0, server, -1, true);
      }
    }

    Engine.setMonitor(new ChatMonitor());
    Engine.displayGraph();
    Engine.runShell();
  }
}
