/******************************************************************
*
* Software Systems Research Laboratory
* Department of Electrical Engineering and Computer Science
* University of Michigan at Ann Arbor
* 1301 Beal Avenue, Ann Arbor, MI 48105
* 
*
* Copyright (c) 2000 The Regents of The University of Michigan.
* All rights reserved.
* 
* Contact: radu@eecs.umich.edu
* Author : SaiVilasini Niranjan(sniranja@eecs.umich.edu)
*******************************************************************/

/******************************************************************
*** File Daemon.java 
***
***/
package dacia.apps.proxy;

import dacia.*;
import dacia.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import java.io.Serializable;
import java.net.*;
import java.io.*;
import java.util.*;


/** 
  * Class: Daemon is the  Web daemon thread. creates main socket on port 8080
  *  and listens on it forever. For each client request,creates proxy thread 
  * to handle the request.
  */




public class Daemon extends Proc implements Serializable
{
	
	//proxy host interface variables : change them as appropriate
	String Proxy_Host = "nand.engin.umich.edu";
	String Proxy_Port = "8080";
	
	// Member variables
	static ServerSocket MainSocket = null;
    	static Cache cache = null;
	static Config config;
	static String adminPath;
 	static String CR ="\r\n";
	final static int defaultDaemonPort =8080;
	final static int maxDaemonPort = 65536;
	Hashtable recvdProcs = null;
/**
  * Constructor
  */
	public Daemon(){
		
		super("ProxyServer", 2);
	
	
	} 
	
	

/**
  * Handle Messages to the Server from the WebFilter 
  */	

	public void handleMessage(Message msg, int portNum) {
 
 		workerThreads work;
 		work  = new workerThreads(this, msg, portNum);
		  work.run();

		}

	public void handlemsg(Message msg, int portNum){

		int recv_port = portNum;
		String request = (String)msg.getData();
		File tempfile = serveTheClient(request, recv_port);  
		//System.out.println("request sent..\n");


		}

	public  void handleAsyncMessage(){

		Message msg;
   		 while(true) {
     			 if((msg = getMessage()) == null)
        			return;
      			handleMessage(msg, msg.getPort());
   			 }

		}
/**
  * Send the  Reply Message to the WebFilter Proc
  */
 	void sendMessage(String message) {
   	
		String request = message;
 		Message msg = new Message();
  		msg.setData((Object)request);
    		output(0, msg, 1);

 		 }
	
/**
  * Main Function that creates a Main Socket to listen for requests 
  */

	public static void proxyDaemon(String[] args)
	{
		int daemonPort;
		daemonPort = defaultDaemonPort;			
		
		try
		{
			// Create the Cache Manager and Configuration objects
			//System.out.println("Initializing...");
			System.out.print("Creating Config Object...");
			config = new Config();
			config.setIsAppletContext(false);
			config.setLocalHost(InetAddress.getLocalHost().getHostName());
			String tmp = InetAddress.getLocalHost().toString();
			config.setLocalIP(tmp.substring(tmp.indexOf('/')+1));
			config.setProxyMachineNameAndPort(InetAddress.getLocalHost().getHostName()+":"+daemonPort);
			File adminDir = new File("Applet");
			config.setAdminPath(adminDir.getAbsolutePath());
			System.out.println("\nOK");
			System.out.print("Creating Cache Manager...");
			cache = new Cache(config);
			System.out.println("OK");
			// Start the admin thread
			Admin adminThd = new Admin(config,cache); 
			adminThd.start();
			// Create main socket
           		System.out.print("Creating Daemon Socket...");
			MainSocket = new ServerSocket(daemonPort);
			System.out.println(" port " + daemonPort + " OK");
			System.out.println("Proxy up and running!");
 		
			// Main loop
			while (true)
			{
				// Listen on main socket
				Socket ClientSocket = MainSocket.accept();

				// Pass request to new proxy thread
				Proxy thd = new Proxy(ClientSocket,cache,config);
				thd.run();
				
			}
			
		}catch (Exception e){}

		finally
		{
			try
			{
				MainSocket.close();
			}
			catch (Exception exc){}
		}
	}

/**
  * Function that Conveys the requests at the dacia port to the Main Socket
  * of the proxy server
  */
	public File serveTheClient(String request, int recvport){

		Socket socket = null;
		OutputStream to_file;
		to_file = null;
		File temp = new File("temp");
		Message msg1 = new Message();
		int recv_port = recvport;
		
		try {
 
        		to_file = new FileOutputStream( temp);    
 			URL url = new URL(request);
	             	String protocol = url.getProtocol();
             		
			if (!protocol.equals("http"))
               			throw new IllegalArgumentException("URL must use 'http:' protocol");
             		
			String host = url.getHost();
             		int port = url.getPort();
             		if (port == -1) 
				port = 80;  // if no port, use the default HTTP port
             		
			String filename = url.getFile();
             
			// Modify system properties
			Properties sysProperties = System.getProperties();

			// Specify proxy settings
			sysProperties.put("proxyHost", Proxy_Host);
			sysProperties.put("proxyPort", Proxy_Port);
			sysProperties.put("proxySet",  "true");


			String proxyhost = sysProperties.getProperty("proxyHost");
			String proxyport = sysProperties.getProperty("proxyPort");
   			int portofproxy = Integer.parseInt(proxyport);    
      
      	  
             		// Open a network socket connection to the specified host and port
            		socket = new Socket( proxyhost,portofproxy  );


             		// Get input and output streams for the socket
             		InputStream from_server = socket.getInputStream();
             		PrintWriter to_server = 
               				new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
             
             		// Send the HTTP GET command to the Web server, specifying the file.
             		// This uses an old and very simple version of the HTTP protocol
             
	     		to_server.println("GET " +"http://"+host+filename);
        		to_server.println(CR);
	     		if(request.startsWith("http://www.cnn.com/WEATHER/nc/MI"))
	     				to_server.println("Pragma: no-cache");
             		to_server.println(CR);//"pragma: no-cache" + CR);
             		to_server.flush();  // Send it right now!
             		to_server.println(CR);
	     		to_server.flush();  // Send it right now!


	     		// Now read the server's response, and write it to the file
             		byte[] buffer = new byte[4096];
             		int bytes_read;
            		
			while((bytes_read = from_server.read(buffer)) != -1){
			      
               			msg1.setData((Object)(new String(buffer,0 , bytes_read)));
    				output(recv_port, msg1, 1);
   				to_file.write(buffer, 0, bytes_read);
               
               
             			  }
	
             		// When the server closes the connection, we close our stuff
             		socket.close();
             		to_file.close();
           	} catch (Exception e) {    // Report any errors that arise
             		
			System.err.println(e);
            
           		}
  		 try{   
			socket.close();
			to_file.close();


		} catch(Exception eh){}

		return temp;
		}
		
}

/**
  * to handle requests from mutliple clients..
  */
	class workerThreads extends Thread {
		
		private Daemon myd = null;
		private dacia.Message  mssg;
		private int portNo;

		protected workerThreads(Daemon d , dacia.Message msg, int portNum){


			myd =d;
			mssg = msg;
			portNo = portNum;
		}

		public void run(){
			
			myd.handlemsg(mssg, portNo);
		}



	}


