/******************************************************************
*
* Software Systems Research Laboratory
* Department of Electrical Engineering and Computer Science
* University of Michigan at Ann Arbor
* 1301 Beal Avenue, Ann Arbor, MI 48105
* 
*
* Copyright (c) 2000 The Regents of The University of Michigan.
* All rights reserved.
* 
* Contact: radu@eecs.umich.edu
* Author : SaiVilasini Niranjan(sniranja@eecs.umich.edu)
*******************************************************************/

package dacia.apps.webclient;

import dacia.*;
import dacia.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;






/**
 * Implements the Client PROC, having 1 port. Displays in the output textArea
 * the messages received on the port. Outputs the messages typed in the
 * input textArea to the Filter Client.
 */

public class WebClient extends Proc  implements Serializable{
  
  	WebClientFrame frame = null;
  	String text = null;
  	int msgID = 0;
  	boolean isParked = false;
  	String mailTo = null; 
	File temp1 = new File("temp1");
	public Message  mssg= null;

/**
  * Constructor
  */
 public WebClient() {
    		
		
	super("Web Client", 1);
	frame = new WebClientFrame(this);
    	mssg = new Message();
  	}
/**
  * Handle messages Recieved from the WebFilter
  */
 public void handleMessage(Message msg, int port){
 
    	synchronized(this) {
  		
 		OutputStream to_file;
		to_file = null;

 		try{
     
     			to_file = new FileOutputStream( "temp1", true);
 			String messg=new String((String)msg.getData());
			to_file.write(messg.getBytes());		
	 		to_file.close();
		} catch(Exception x){}		     

        	if(!isParked){
       			displayHtml();
       			}
       		else{
  			 if(mailTo != null) {
         
	 		 // send email to the specified address
        		System.out.println("Send mail to " + mailTo + ": " );
          
			InputStream f;
			DataInputStream din;
			String newbuf;
 			
			try{

			f = new FileInputStream(new File("temp1"));
			int len_file = f.available();
			byte[] buf = new byte[len_file];
			din = new DataInputStream(f);
			din.readFully(buf);

			newbuf = new String(buf);
			System.out.println("\n length : " + len_file +"\n");
			sendmail(mailTo, msg.origin, newbuf);
		
			}catch(Exception eex){
			
				System.out.println("Exception in procedure called when Parked :" + eex); }

          			}
  
    		}
	}
 }



 public void handleAsyncMessage() {
	
	
	Message msg = null;
    	
	while(true) {
      		if((msg = getMessage()) == null)
	   		 return;
		handleMessage(msg, 0);
   
    	}

}


/**
  * function to display the html file sent by the filter  on the Client's Frame
  */
void displayHtml(){

	InputStream f;
	OutputStream out;
	DataInputStream din;

 	try{

		f = new FileInputStream(new File("temp1"));
		int len_file = f.available();
		byte[] buf = new byte[len_file];
		din = new DataInputStream(f);
		din.readFully(buf);
		String newbuf = new String(buf);
		//System.out.println("\n length : " + len_file +"\n");


		if((newbuf.indexOf("</html>") != -1) || (newbuf.indexOf("</HTML>") != -1)){

			
			 BufferedReader in = new BufferedReader(new StringReader(newbuf));
			frame.htmlKit.read(in, frame.displayArea.getDocument(),0);
		   }

		f.close();
 		
		
	  }catch(Exception x){System.out.println("\n Exception here"+x); }

	return;

}

  
/**
  * function to send messages to a Proc Connected to the Port of this proc  
  */
void sendMessage(String message) {

	
	String request = message;
 	
	if(!(request.startsWith("http") || request.startsWith("HTTP")))
	
		if(!(request.startsWith("www."))){
		   	 	
				String temp = "http://www.".concat(request);
		    		request=temp;
			}
	        else{ 
				
				String temp1 = "http://".concat(request);
		      		request = temp1;
			}

	Message msg = new Message();
    	msg.id = msgID++;
	msg.origin = getID();
 
	try{
	
		javax.swing.text.html.HTMLEditorKit  d = frame.htmlKit;
		d.deinstall(frame.displayArea);
		javax.swing.text.html.HTMLEditorKit d1 = new javax.swing.text.html.HTMLEditorKit();
		frame.displayArea.setEditorKit(d1);

	
		}catch(Exception eee){System.out.println("\n EXCEPTION in Send Message: " + eee + "\n");}


	temp1.delete();
	msg.setData((Object)request);
	output(0, msg, 1);

}


/**
  * function to pack the WebClient Proc 
  */
 public void pack() {
 
    if(!isParked) {
      text = frame.getText();
      frame.quit();
      frame = null;
    }
  }


/**
  * function to UnPack the WebClient Proc
   */ 
 public void unpack() {
    
    if(!isParked) {
 
 	frame = new WebClientFrame(this);
   	/* After retreiving the Text,display the HTML file on the Frame */
 		OutputStream to_file;
		to_file = null;
		if(temp1.exists())
			temp1.delete();
			File temp1 = new File("temp1");
 		try{
     
     			to_file = new FileOutputStream( "temp1");
 			
			to_file.write(text.getBytes());		
	 		to_file.close();
		} catch(Exception x){}	
      
      
      displayHtml();
      
      
      
      
    }
 }

/**
  * function to park the WebClient Proc
   */
void park(String hostname, String emailaddr) {
    
    System.out.println("park(" +getID() +", " +hostname +", " + emailaddr+")");
    
    mailTo = emailaddr;
    
    synchronized(this) {
      	pack();
      	isParked = true;
    }
    
    if(hostname != null) {
      	Connection connection;
      	if((connection = Engine.getConnection(hostname)) != null) {
        		
			Engine.moveProc(this, connection);
     	 }
    }

}

 
/**
  * function to start the parked WebClient Proc
  */
 
public void start() {
    
    if(isParked) {
      	
	synchronized(this) {
        		
			isParked = false;
        		unpack();
      		}
     	
	mailTo = null;
    }
}

/**
  * send mail to the client if the WebClient is not connected
   */
void sendmail(String recipient, int sender, String message) {
   
   
   	String hostname = null;
	int i = recipient.indexOf("@");
    
    	if(i > 0) {
      		hostname = recipient.substring(i+1);
    	}
    	try {   

      		Socket s = new Socket(hostname, 25);
		BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream(), "8859_1"));
      		BufferedWriter out = new BufferedWriter(new OutputStreamWriter(s.getOutputStream(), "8859_1"));

      		// warning : some mail server validate the sender address
      		//           in the MAIL FROM command, put your real address here
     		sendln(in, out, "MAIL FROM: <sniranja@eecs.umich.edu>");
      		sendln(in, out, "RCPT TO: <" + recipient +">" );
      		sendln(in, out, "DATA");
      		sendln(out, "Subject: DACIA News/Weather message");
      		sendln(out, "From: Dacia Web Filter " + (new Integer(sender)).toString() +" <daciaWeb@DACIA>");
      		sendln(out, "To: <" + recipient + ">");

      		// Send the body
      		sendln(out, message);
      		sendln(in, out,".");
      		sendln(in, out, "QUIT");
      		s.close();
    
    	}catch (Exception e) {
 			
			e.printStackTrace();
    		}
}

   
/**
  * functions that are called internally to send a line
   */
public void sendln(BufferedReader in, BufferedWriter out, String s) {
    
    	try {
     		 
		out.write(s + "\r\n");
      		out.flush();
		s = in.readLine();
     
    	}catch (Exception e) {
      
      		e.printStackTrace();
    	}
}


public void sendln(BufferedWriter out, String s) {
    
    	try {
     		
		out.write(s + "\r\n");
      		out.flush();
      		//System.out.println(s);
    	
	}catch (Exception e) {
      
      		e.printStackTrace();
    	 }
 } 

}



/**
  * WebClientFrame Class for creating a Frame for the WebClient Proc
  */


class WebClientFrame extends JPanel implements ActionListener,Serializable{
  
  
  	WebClient pclient;
  	JButton sendButton = null;
  	JButton News = null;
  	JButton Display = null;
  	JMenuItem startItem = null;
  	JMenuItem stopItem = null;
  	JMenuItem parkItem = null;
  	JTextField editText = null;
    	//JTextArea displayArea = null;
  	static JFrame f;
  	public Vector v;
  	JMenuBar aMenuBar = null;
  	JMenu aMenu;
  	JScrollPane scrollPane;
 	static JEditorPane displayArea ; //= null;
	static HTMLEditorKit htmlKit;
  
/**
  * function to display the Weather Dialog  to get the Client's Email address, Temperature and City
  */
  	public void getWeatherDialog()
  	{
  		MailDialog mdlg = new MailDialog(this);
		pclient.sendMessage("http://EMAIL."+mdlg.emailaddr);
		pclient.sendMessage("http://CITY."+mdlg.city_name);
		pclient.sendMessage("http://TEMPCMP."+mdlg.tmp_cmp);
  	}
  
/**
  * Constructor 
  */
  	public WebClientFrame(WebClient target) {
      
   
   		 f =new JFrame("pclient: " + target.getID());
    		pclient = target;
    		f.setSize(350, 250);
    		Font font = new Font("sanserif", Font.PLAIN|Font.BOLD, 14);
    		f.setFont(font);
    		//displayArea = new JTextArea(7,40);
    		displayArea = new JEditorPane();
    		//displayArea.createEditorKitForContentType("text/html");
 		//displayArea.createEditorKitForContentType("text/html");
    		displayArea.setEditable(false);

		displayArea.addHyperlinkListener( new HyperlinkListener(){

				public void hyperlinkUpdate(HyperlinkEvent e) {
                  			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
				                 String link_source = e.getURL().toString();
		    				//System.out.println("\n" + link_source + "\n");
		    				if(link_source.startsWith("http://dacia/pclient/Weather_in_mich.html")){
		    
		    					getWeatherDialog();
		   				 }
		    				else	
		   					 pclient.sendMessage(link_source);
			
					if(!(link_source.startsWith("http://www.<")) &&
						!(link_source.startsWith("http://www.>")) &&
						!(link_source.startsWith("http://www.Emailme")))
			
						 editText.setText(link_source);
                        		//editText.requestFocus();
		    
					}
 				}
 			} );

    
   
    		GridBagLayout gridbag = new GridBagLayout();
    		f.getContentPane().setLayout(gridbag);
    		scrollPane =  new JScrollPane(displayArea, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    		scrollPane.setViewportView(displayArea);
    		sendButton = new JButton("Send");
    		News = new JButton("Load");
    		Display = new JButton("Display Services");
    		editText = new JTextField();
   		htmlKit = new HTMLEditorKit();
   		editText.addActionListener((ActionListener)this);
		displayArea.setEditorKit(htmlKit);
		//displayArea.setContentType("text/html");

   		constrain(f.getContentPane(), new JLabel("Enter a new message:"), 0, 0, 2, 1, 0, 0, 0, 0);
    		constrain(f.getContentPane(), editText, 0, 1, 1, 1, 
		   GridBagConstraints.HORIZONTAL,
		   GridBagConstraints.NORTHWEST,
		   10.0, 0.0, 0, 0, 0, 0);
    		constrain(f.getContentPane(), sendButton, 1, 1, 1, 1, 
		   GridBagConstraints.HORIZONTAL,
		   GridBagConstraints.NORTHWEST,
		   1, 0.0, 0, 0, 0, 0);
		   /*was 1,3,2,1...1,0.0,0,0,0,0*/
    		constrain(f.getContentPane(), News, 1, 2, 1, 1, 
		   GridBagConstraints.HORIZONTAL,
		   GridBagConstraints.NORTHWEST,
		   1.0, 0.0, 0, 0, 0, 0);	 
		   /*was 0,3,2,1...1,0.0,0,0,0,0*/
    		constrain(f.getContentPane(), Display, 0, 2, 1, 1, 
		   GridBagConstraints.HORIZONTAL,
		   GridBagConstraints.NORTHWEST,
		   1.0, 0.0, 0, 0, 0, 0);	
  		 constrain(f.getContentPane(), scrollPane, 0, 4, 2, 1, 
		   GridBagConstraints.BOTH,
		   GridBagConstraints.CENTER,
		   1.0, 1.0, 0, 0, 1, 0);


    		// set up the menu bar

    		aMenu = new JMenu("Menu");
  		
		startItem = new JMenuItem("Start");
    		startItem.addActionListener((ActionListener)this);
    		aMenu.add(startItem);
    		
		parkItem = new JMenuItem("Park");
    		parkItem.addActionListener((ActionListener)this);
    		aMenu.add(parkItem);
    
    		stopItem = new JMenuItem("Quit");
    		stopItem.addActionListener((ActionListener)this);
    		aMenu.add(stopItem);

    		aMenuBar = new JMenuBar();
    		aMenuBar.add(aMenu);
    		f.setJMenuBar(aMenuBar);
    
    		sendButton.addActionListener(this);
    		News.addActionListener(this);
    		Display.addActionListener(this);
    
    
    		v= new Vector();
     		try {
          			
			BufferedReader in = new BufferedReader( new FileReader("dacia/apps/webclient/MichiganCities.txt"));
    			String str;
  			while ((str = in.readLine()) != null) 
 				
				v.add((Object)str);

 

			in.close();
		}catch (IOException e) {System.out.println("\n\n Exception in adding the Hash Map:" + e +"\n"); }
 
    		f.pack();
    		f.setVisible(true);

}




/**
  * function to process menu commands
  */
public void actionPerformed(ActionEvent e) {
   
   
   		 try{
     		
			if(e.getActionCommand().equals("Start")) {}
      			
			else if(e.getActionCommand().equals("Park")) {
        		
				ParkDialog dialog = new ParkDialog(this);
      			}
     
     			else if(e.getActionCommand().equals("Quit")) {
        		
				f.setVisible(false);
        			f.dispose();
        
     			 }
     
     			 else if(e.getActionCommand().equals("Send") ){
      
        			pclient.sendMessage(editText.getText());
				editText.setText("");
        			editText.requestFocus();
      
   			 }
      			
			else if(e.getActionCommand().equals(editText.getText())) {
	
				pclient.sendMessage(editText.getText());
				editText.setText("");
       				editText.requestFocus();
      			}
     
     			else if(e.getActionCommand().equals("Load") ){
      
      				pclient.sendMessage("Load");
				editText.setText("");
        			editText.requestFocus();

     			 }
     
     			 else if(e.getActionCommand().equals("Display Services") ){
      
				pclient.sendMessage("display previous");
				editText.setText("");
        			editText.requestFocus();
      
      			}
      
     			 else
        			System.out.println("pclient: unknown menu item: " + e.getActionCommand());
    	
		}catch(Exception ex) {
      			
			System.out.println("pclient: exception: "+ex.getMessage());
      			ex.printStackTrace();
    			}
}

/**
  * function to dispose the WebClientFrame
  */  
void quit() {
    
    		f.setVisible(false);
    		//f.dispose();
}


// the gridbag layout stuff from the Java NutShell book
void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int fill, int anchor, double weight_x, double weight_y,
			int top, int left, int bottom, int right) {
			
			
			
    		GridBagConstraints c = new GridBagConstraints();
    		c.gridx = grid_x; c.gridy = grid_y;
    		c.gridwidth = grid_width; c.gridheight = grid_height;
    		c.fill = fill; c.anchor = anchor;
    		c.weightx = weight_x; c.weighty = weight_y;
    		if (top+bottom+left+right > 0)
     			 c.insets = new Insets(top, left, bottom, right);
    
    		((GridBagLayout)container.getLayout()).setConstraints(component, c);
    		container.add(component);
 
}

  
void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int top, int left, int bottom, int right) {
   
   	 constrain(container, component, grid_x, grid_y,
              grid_width, grid_height, GridBagConstraints.NONE,
              GridBagConstraints.NORTHWEST,
              0.0, 0.0, top, left, bottom, right);
}

/**
  * function to return the HTML text contained in the WebClientFrame
  */
String getText() {

    		return displayArea.getText();
}

  
//void displayText(String str) {}
 
//void displayMessage(String str) {}


}


/**
  * Class for creating a Dialog to get Weather Information 
  */
class MailDialog extends Dialog implements ActionListener { 


		WebClientFrame proxyClientFrame;
  		Checkbox mail;
  		TextField email; 
  		TextField temperature;
  		TextField city;	
  		Label temp1 ;
  		Label city2;
  		Label Email3;
  
		public String emailaddr = null;
		public String tmp_cmp=null;
		public String city_name = null;
	
/**
  * Constructor 
  */
  	public MailDialog(WebClientFrame parent) { 
               
	 		super(parent.f, "Mail  pclient", true);
                	
			proxyClientFrame = parent;
			setFont(new Font("sanserif", Font.PLAIN, 12));
			GridBagLayout g = new GridBagLayout();
			setLayout(g);	
			GridBagConstraints gbc = new GridBagConstraints(); 

		

			Email3 = new Label("Email Address ");
			gbc.insets = new Insets(0, 5, 0, 0);
			gbc.gridx = 1; 	
			gbc.gridy = 1;	
			gbc.gridwidth = 1;  		
			g.setConstraints(Email3, gbc); 
			add(Email3);

			email = new TextField(30); 		
			gbc.gridx = 2; 		
			gbc.gridwidth = 2; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(email, gbc); 
			add(email); 
		
			temp1 = new Label("Temperature");
			gbc.gridx = 1; 
			gbc.gridy = 2;		
			gbc.gridwidth = 1; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(temp1, gbc); 
			add(temp1); 
		
		
			temperature = new TextField(5); 		
			gbc.gridx = 2; 
			gbc.gridy = 2;		
			gbc.gridwidth = 2; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(temperature, gbc); 
			add(temperature); 
		
			city2  = new Label("City: eg: AnnArbor");
			gbc.gridx = 1; 
			gbc.gridy = 3;		
			gbc.gridwidth = 1; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(city2, gbc); 
			add(city2); 
			
			city = new TextField(15); 		
			gbc.gridx = 2; 	//2
			gbc.gridy = 3;	
			gbc.gridwidth = 2; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(city, gbc); 
			add(city); 

			Button ok = new Button("OK");  	
			ok.addActionListener(this);
			gbc.gridx = 1; 		
			gbc.gridy = 4;
			//gbc.anchor = GridBagConstraints.EAST;
			g.setConstraints(ok, gbc); 
			add(ok);  		
		
			Button cancel = new Button("Cancel");  		
			cancel.addActionListener(this);
			gbc.gridx = 2; 
			gbc.gridy = 4;	
			//gbc.anchor = GridBagConstraints.CENTER;
			g.setConstraints(cancel, gbc); 
			add(cancel);  	 

   
			setSize(400, 200);
			setResizable(false); 
			show();
      
      } 
	
	

     public void actionPerformed(ActionEvent e) {
   
   
   		 //String  emailaddr = null;
    		//String hostname = "hostname", emailaddr = "emailaddr";
		String label = ((Button)e.getSource()).getLabel();
		
		if(label.equals("OK")) {
				
				tmp_cmp = temperature.getText();
				city_name = city.getText();
				emailaddr = email.getText();
				dispose();
			
			
			//IMP TODO if any of the inputs r null..throw a invalid input dialog box error :)
      
		}
		
		if (label.equals("Cancel"))
				
				dispose(); 
				
     }
     
} 



/** 
  * Class for Park Dialog Box
  */
class ParkDialog extends Dialog implements ActionListener { 

		WebClientFrame proxyClientFrame;
		Checkbox move, mail;
  		Choice host; 	
  		TextField email; 	

 /** 
   * Constructor 
   */
	public ParkDialog(WebClientFrame parent) { 
                
			//super(parent, "Park  pclient", true);
			super(parent.f, "Park  pclient", true);
                	proxyClientFrame = parent;
			setFont(new Font("sanserif", Font.PLAIN, 12));
		
			GridBagLayout g = new GridBagLayout();
			setLayout(g);	
			GridBagConstraints gbc = new GridBagConstraints(); 

			move = new Checkbox("Move to host", false);
			gbc.weighty = 1.0; 	
			gbc.insets = new Insets(0, 10, 0, 0);
			gbc.gridx = 1; 	
			gbc.gridy = 1;	
			gbc.gridwidth = 1;  		
			g.setConstraints(move, gbc); 
			add(move);

			host = new Choice();
			gbc.gridx = 2; 	
			gbc.gridwidth = 1; 
			g.setConstraints(host, gbc); 
			add(host);
		
			mail = new Checkbox("Send email to", false);
			gbc.insets = new Insets(0, 10, 0, 0);
			gbc.gridx = 1; 	
			gbc.gridy = 2;	
			gbc.gridwidth = 1;  		
			g.setConstraints(mail, gbc); 
			add(mail);

			email = new TextField(30); 		
			gbc.gridx = 2; 		
			gbc.gridwidth = 2; 
			gbc.anchor = GridBagConstraints.WEST;
			g.setConstraints(email, gbc); 
			add(email); 

			Button ok = new Button("OK");  	
			ok.addActionListener(this);
			gbc.gridx = 2; 		
			gbc.gridy = 4;
			//gbc.anchor = GridBagConstraints.EAST;
			g.setConstraints(ok, gbc); 
			add(ok);  		
		
			Button cancel = new Button("Cancel");  		
			cancel.addActionListener(this);
			gbc.gridx = 3; 	
			//gbc.anchor = GridBagConstraints.CENTER;
			g.setConstraints(cancel, gbc); 
			add(cancel);  	 

    			host.addItem("          ");
    			Vector connections = Engine.getConnections();
    			for(int i=0; i<connections.size(); i++)
     				 host.addItem(((Connection)connections.elementAt(i)).getHostname());

			setSize(370, 150);
			setResizable(false); 
			show();
         } 
	
	
     public void actionPerformed(ActionEvent e) {
    
    			String hostname = null, emailaddr = null;
    			//String hostname = "hostname", emailaddr = "emailaddr";
			String label = ((Button)e.getSource()).getLabel();
		
			if(label.equals("OK")) {
					if(move.getState())
        					if(!host.getSelectedItem().equals("          "))
         						 hostname = host.getSelectedItem();
						if(mail.getState())
							emailaddr = email.getText();
						dispose();
      					proxyClientFrame.pclient.park(hostname, emailaddr);
		
					
			}
		
			if (label.equals("Cancel"))
					
					dispose(); 
       }
       
       
} 

