/******************************************************************
*
* Software Systems Research Laboratory
* Department of Electrical Engineering and Computer Science
* University of Michigan at Ann Arbor
* 1301 Beal Avenue, Ann Arbor, MI 48105
* 
*
* Copyright (c) 2000 The Regents of The University of Michigan.
* All rights reserved.
* 
* Contact: radu@eecs.umich.edu
* Author : SaiVilasini Niranjan(sniranja@eecs.umich.edu)
*******************************************************************/

package dacia.apps.webclient;

import dacia.*;
import dacia.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import dacia.Engine;

/**
 * Implements the Filter PROC, having 2 port. Receives Messages from the Client
 * and if any further processing is required, it does that and forwards the request to
 * proxy, gets the reply and after filtering it to get the reqd. result, sends it to the
 * client
 */
 
public class WebFilter extends Proc {     
	public int Sync_Async =0;
	File temp2 = new File("temp2") ;
	Map map;
	Vector v;
 	public String url_combo_selctn ="http://www.cnn.com/WEATHER/nc/MI/AnnArborARB.html";
 	public int tempcompare = 0;
 	public int hi[];
	public int lo[];
 
 	public String mailTo = "sniranja@eecs.umich.edu";
 	public String cityTo ="AnnArbor";
/**
  * Constructor 
  */  
public WebFilter(){

		super("FILTER FOR CLIENT" , 2);  

		if(temp2.exists())temp2.delete();
		temp2 = new File("temp2");

		/* create a hash map for the states */

		v= new Vector();
		map = new HashMap();    // hash table
		map = new TreeMap();    // sorted map
		String key = null;
		String value = null;
		
   		try {
			
          	BufferedReader in = new BufferedReader(
                                 new FileReader("dacia/apps/webclient/MichiganStates.txt"));
    		String str;
  		while ((str = in.readLine()) != null) {
 
 		StringTokenizer parser = new StringTokenizer(str);
                      
		while (parser.hasMoreTokens()) {
		key = parser.nextToken();
		value = parser.nextToken();
		v.add((Object)key);
		map.put(key, value); 


		}
 
		}
		in.close();
 		} catch (IOException e) {System.out.println("\n\n Exception in Creating"
		+"a Map of the Cities in Michigan:" + e +"\n"); }
 
}


 	static int k =0 ;
 	static int i =0 ;
/**
  * Function that extracts the Temperatures and does the Comparision 
  */
public int  tempWatch(){


	InputStream f;
	BufferedReader din;
	String  stemp = null;
	String high;
	String low;
	String curtemp;
	int curt=0;
	hi = new int[5];
	lo = new int[5];

		
	//DataInputStream din;
 	try{
 
		f = new FileInputStream("temp2");
		int len_file = f.available();
		byte[] buf = new byte[len_file];
		din = new BufferedReader(new InputStreamReader(f));
		
		do{
			stemp = din.readLine();
 			if(stemp == null)
				break;
			if(stemp.indexOf("LOW") != -1){
				stemp = din.readLine();
				int index_low = stemp.indexOf("<span class=\"greytemps\">");
				int end = stemp.indexOf(" F<BR>");
				low = stemp.substring(index_low+ "<span class=\"greytemps\">".length(), end);
				Short sh = new Short(low);
				lo[i] = sh.intValue();
				i++;
				if(i ==5) 
					i=0;
			}

			else if(stemp.indexOf("HIGH") != -1){
				stemp = din.readLine();
				int index_high = stemp.indexOf("<span class=\"redtemps\">");
				int endh = stemp.indexOf(" F<BR>");
				high = stemp.substring(index_high+ "<span class=\"redtemps\">".length(), endh);
				Short sh = new Short(high);
				hi[k] = sh.intValue();
				k++;
				if(k == 5) 
					k =0;
			}
			else if(stemp.indexOf("<span class=\"FSnPSmDk\">Temp:</span>  <span class=\"FSnBSmDk12\">") != -1){
	
				int index_curtemp = stemp.indexOf("<span class=\"FSnPSmDk\">Temp:</span>  <span class=\"FSnBSmDk12\">");
				int endcur = stemp.indexOf(" F,"); //    16 C</span><BR>
				int l="<span class=\"FSnPSmDk\">Temp:</span>  <span class=\"FSnBSmDk12\">".length();
				curtemp	= stemp.substring(index_curtemp + l , endcur);
				Short sh = new Short(curtemp);
				curt = sh.intValue();
				//System.out.println("here\n Current Temp " + curt);

			}
	
		}while(stemp != null); 
		
	f.close();

	}catch(Exception xc){System.out.println("\n EXCPTION in Temp Compare Function" + xc);}

	return curt;


}
/**
  *Send Mail to the Client if the Client is not connected
  */
void sendmail(String recipient, int sender, String message) {
    		
		
		if(recipient != null)
		{
		String hostname = null;
		int i = recipient.indexOf("@");
    		if(i > 0) {
      			hostname = recipient.substring(i+1);
    		}
    		
		try {   
			Socket s = new Socket(hostname, 25);
			BufferedReader in = new BufferedReader
        			(new InputStreamReader(s.getInputStream(), "8859_1"));
      			BufferedWriter out = new BufferedWriter
        			(new OutputStreamWriter(s.getOutputStream(), "8859_1"));
			
			// warning : some mail server validate the sender address
      			//           in the MAIL FROM command, put your real address here
      
      			sendln(in, out, "MAIL FROM: <sniranja@eecs.umich.edu>");
      			sendln(in, out, "RCPT TO: <" + recipient +">" );
      			sendln(in, out, "DATA");
      			sendln(out, "Subject: DACIA Weather Info message");
      			sendln(out, "From: Dacia Weather Filter " + (new Integer(sender)).toString() +
             						" <Weather@DACIA>");
      			sendln(out, "To: <" + recipient + ">");

     			 // Send the body
      			sendln(out, message);
      			sendln(in, out,".");
      			sendln(in, out, "QUIT");
      			s.close();
    		}catch (Exception e) {
      			e.printStackTrace();
    				}
 
 
 	}
 
 
  }
 /**
   * internal function to send a line 
   */  
public void sendln(BufferedReader in, BufferedWriter out, String s) {
    		try {
      			out.write(s + "\r\n");
      			out.flush();
			s = in.readLine();
     		 }catch (Exception e) {
     			 e.printStackTrace();
    			}
}

public void sendln(BufferedWriter out, String s) {
    		try {
      			out.write(s + "\r\n");
      			out.flush();
      			System.out.println(s);
    		}catch (Exception e) {
      			e.printStackTrace();
    			}
} 


/**
  * function for filtering the requetsed Weather page before sending it to the client 
  */
public void filterWeather(Message msg , int Async){

	Async = 0;
	InputStream f;
	DataInputStream din;
	OutputStream to_file;
	to_file = null;
 	
	try{
		f = new FileInputStream(new File("temp2"));
		int len_file = f.available();
		byte[] buf = new byte[len_file];
		din = new DataInputStream(f);
		din.readFully(buf);
		String newbuf = new String(buf);
		
		
		if((newbuf.indexOf("</html>") != -1) || (newbuf.indexOf("</HTML>") != -1)){

		/*ok do it here alter the file and then send a messge to client ...by output func */

		int index_html  = newbuf.indexOf("<html>");
		if(index_html == -1)
			index_html = newbuf.indexOf("<HTML>");
		
		int index_end_head = newbuf.indexOf("</head>");	
		if(index_end_head == -1)
			index_end_head = newbuf.indexOf("</HEAD>");

		String new_one = newbuf.substring(index_html , index_end_head );
		String new_1 = new_one.concat("</head><body bgcolor=\"#FFFFFF\"><table width=\"770\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>");
		
		int index_cur_conds = 
			newbuf.indexOf("<!-- =========================== Current Conditions ============================= -->");
		int index_end_curconds = 
			newbuf.indexOf("<!-- ============================ /Four Day Forcast ============================= -->");

		String new_2 = newbuf.substring(index_cur_conds , index_end_curconds);
		String new_3 = new_1.concat(new_2);
		String new_final = new_3.concat("</TR></TABLE></TR></body></html>");
		f.close();
		
		temp2.delete();
		/*rewrite the same file with the filtered contents */
		temp2 = new File("temp2");
		to_file = new FileOutputStream( "temp2");
		to_file.write(new_final.getBytes());		

		 int temp_cur =  tempWatch();
 
		String send_new_final = new String("Current Temp is : " + temp_cur);
		String hih;
		String loe;
		for(int j =0 ; j<5; j++){
			loe = "\n\n" + "day " + j+ ": temp low " + lo[j];
			String ts = send_new_final.concat(loe);
			send_new_final = ts;
		}
		for(int l =0 ; l<5; l++){
			hih = "\n\n" + "day " + l+ ": temp high" + hi[l];
			String ts1 = send_new_final.concat(hih);
			send_new_final = ts1;
	
	
		}	
		if(temp_cur <= tempcompare){
 	
			msg.setData((Object)new_final);

			Port theport = port[0];
			if(theport.connectionStatus == 0){
			//System.out.println("\n Cant Send mssge the pclient is not connected");
			sendmail(mailTo, msg.origin, send_new_final);

			}
			else{
			output(0,msg,Async);
			}
		}
		else {

			if(temp2.exists())temp2.delete();
			msg.setData((Object)url_combo_selctn); 
			output(1,msg,0);
		}
	
	}

	}catch(Exception c){}
	/*if the line does not have </html > it means  the file is nt  yet sent fully ..so do nothing wait */

}




/**
  * function for filtering the requetsed News page before sending it to the client 
  */

public void filterNews(Message msg, int Async , int Newsof){

		Async = 0;
		InputStream f5;
		DataInputStream din5;
		OutputStream to_file5;
		to_file5 = null;
 
 		try{

			f5 = new FileInputStream(new File("temp2"));
			int len_file5 = f5.available();
			byte[] buf5 = new byte[len_file5];
			din5 = new DataInputStream(f5);
			din5.readFully(buf5);
			String newbuf5 = new String(buf5);

			if((newbuf5.indexOf("</html>") != -1) || (newbuf5.indexOf("</HTML>") != -1)){

			/*ok do it here alter the file and then send a messge to client ...by output func */

			int index_html  = newbuf5.indexOf("<html>");
			if(index_html == -1)
					index_html = newbuf5.indexOf("<HTML>");

			int index_end_head = newbuf5.indexOf("</head>");	
			if(index_end_head == -1)
					index_end_head = newbuf5.indexOf("</HEAD>");

			String new_one = null;


			if(Newsof == 1)
				new_one = "<html><head><title>CNN.com - U.S. News</title><base href=http://www.cnn.com/US/>"; /*newbuf5.substring(index_html , index_end_head );*/
			else if(Newsof == 0)
				new_one = "<html><head><title>CNN.com - WORLD News</title><base href=http://www.cnn.com/WORLD/>";
			else 
				new_one = "<html><head><title>CNN.com -News</title>";		

			String new_1 = new_one.concat("</head><body bgcolor=\"#FFFFFF\"><table width=\"770\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>");
	
			int index_cur_conds = 
				newbuf5.indexOf("<!-- ================== content ================== -->");
			int index_end_curconds = 
				newbuf5.indexOf("<!-- ================== /content ================== -->");

			String new_2 = newbuf5.substring(index_cur_conds , index_end_curconds);
			String new_3 = new_1.concat(new_2);
			String new_final = new_3.concat("</body></html>");
			
			f5.close();
			
			/*rewrite the same file with the filtered contents */
			temp2.delete();
			temp2 = new File("temp2");
			to_file5 = new FileOutputStream( "temp2");
			to_file5.write(new_final.getBytes());		
			
			to_file5.close();
	
			/*HERE ADD CHK TO SEE OF CLIENT IS CONNECTED..ELSE POP UPA MESG BOX ERROR*/	
			msg.setData((Object)new_final);
			
			
			Port theport = port[0];
			if(theport.connectionStatus == 0){
					
					System.out.println("\n Cant Send mssge the pclient is not connected");
					ErrorMessageBox emb = new ErrorMessageBox(dacia.Engine.graph,"Dis-Connected", "Client is not Connected on Port 0 ");


			}
			else{
			
					output(0,msg,Async);
			
			}
			
			
			
			
			

		}

	}catch(Exception c){}

	/*if the line does not have </html > it means  the file is not  yet sent fully ..so do nothing wait */

}


/** 
  *function for filtering the requetsed page before sending it to the client 
  */
public void filterGeneral(Message msg, int Async){

			Async =0;
			InputStream f4;
			DataInputStream din4;

 			try{

			f4 = new FileInputStream(new File("temp2"));
			int len_file4 = f4.available();
			byte[] buf4 = new byte[len_file4];
			din4 = new DataInputStream(f4);
			din4.readFully(buf4);
			String newbuf4 = new String(buf4);


			if((newbuf4.indexOf("</html>") != -1) || (newbuf4.indexOf("</HTML>") != -1)){
					
					
					int index_html1  = newbuf4.indexOf("<html>");
					if(index_html1 == -1)
							index_html1 = newbuf4.indexOf("<HTML>");

					int index_end1 = newbuf4.indexOf("</html>");	
					if(index_end1 == -1)
							index_end1 = newbuf4.indexOf("</HTML>");

					String new_one1 = newbuf4.substring(index_html1,index_end1+7);
					
					
					msg.setData((Object)new_one1);
					/*HERE ADD CHK TO SEE OF CLIENT IS CONNECTED..ELSE POP UPA MESG BOX ERROR*/
					Port theport = port[0];
					if(theport.connectionStatus == 0){
						System.out.println("\n Cant Send mssge the pclient is not connected");
						ErrorMessageBox emb = new ErrorMessageBox(dacia.Engine.graph,"Dis-Connected", "Client is not Connected on Port 0 ");

					}
					else{
						output(0,msg,Async);
					
					}
		
				}
			/*if the line does not have </html > it means  the file is nOt  yet sent fully ..so do nothing wait */
			
			f4.close();
			}catch(Exception xc){}


}


/**
  * Handle messages from the Client or the Proxy
  */
  
   	/* note : Async = 0 ; Sync = 1;  */

public void handleAsyncMessage() {
Sync_Async=0;
		Message msg = null;
    while(true) {
      if((msg = getMessage()) == null)
        return;

	handleMessage(msg, msg.getPort());
	}
    }
    
    
    
public void handleMessage(Message msg, int port) {
	
	Sync_Async = 0;//send all messages Asynchronously

	/*if the mssge is from the proxy(port 1) then chk for appropriate filter it shuld be sent  to */
	if(port == 1){
      	
	 		OutputStream to_file;
	 		to_file = null;

 			try{
     				to_file = new FileOutputStream( "temp2", true);
 				String messg=new String((String)msg.getData());		
				to_file.write(messg.getBytes());		
	 			to_file.close();
			} catch(Exception x){}	
     
     		 	/* now alter the temp2 file and then  send it to the client ..that is send it to the filters*/
      
      	
			InputStream f3;
			DataInputStream din3;

 		  try{

			f3 = new FileInputStream(new File("temp2"));
			int len_file3 = f3.available();
			byte[] buf3 = new byte[len_file3];
			din3 = new DataInputStream(f3);
			din3.readFully(buf3);
			String newbuf3 = new String(buf3);

			/*first chk if its weather only then send it there..else send  it to other filters*/
	

			if((newbuf3.indexOf("<title>") != -1) || (newbuf3.indexOf("<TITLE>") != -1)){
					
					int start = newbuf3.indexOf("<title>");
					if(start == -1)
						start = newbuf3.indexOf("<TITLE>");
			
					int end  = newbuf3.indexOf("</title>");
					if(end == -1)
						end = newbuf3.indexOf("</TITLE>");
			
					String s = newbuf3.substring(start,end);
					
					if(s.startsWith("<title>CNN.com - Weather"))
							/*send it to WEATHER HANDLER */
							
						filterWeather(msg , 0);
			
		
					else if(s.startsWith("<title>CNN.com") && !s.startsWith("<title>CNN.com - Weather")){
		
						/*NEWS FILTERS */
	
						/*s.startsWith("<title>CNN.com - World News") || s.startsWith("<title>CNN.com - U.S. News")*/
						if(s.startsWith("<title>CNN.com - World News"))
							filterNews(msg,0, 0); //send a msg that its world news : 0
		
						else if(s.startsWith("<title>CNN.com - U.S. News"))
							filterNews(msg,0,1); //send a msg thats its US news : 1
					
						else
							filterNews(msg,0,2);	
		
						}
	
	
					else
						filterGeneral(msg,0);  /*COMMON FILTER...DOESNT DO ANYTHING...just passes on the mssges */
	
			}
	
			f3.close();
	
		}catch(Exception xc){}
	
	/*the title msg has not yet come..dont do anything */

      }
      
      /*if the message is from the client(port 0) then chk it out for different service options provided */
	
else if(filterMatched(msg )){
					
		output(1, msg, 0); /*send all the messages Asynchronously*/
	
	}
}
	
	
/*handle messages ends here  */

/**
  * Function to check the received messages for further filtering
  */    
public boolean filterMatched(Message msg){
		
			int proxyid=0;
			Boolean s= new Boolean("true");
		
			if(msg.getPort() == 0){
				
				String messg=new String((String)msg.getData());
				
				if(messg.equals("http://www.display previous") ||
							messg.equals("http://dacia/pclient/Weather.html")){
		
		
				/*send the Services provided page */
		
					InputStream f;
					DataInputStream din;
 					
					try{

						f = new FileInputStream(new
								File("dacia/apps/webclient/Weather.html"));
						int len_file = f.available();
						byte[] buf = new byte[len_file];
						din = new DataInputStream(f);
						din.readFully(buf);
						String newbuf = new String(buf);
						
						messg = newbuf;
						f.close();
			
			
 					}catch(Exception x){
		
							System.out.println("\n Exception in Filter Matched Function"+x);
							
							}
				
					msg.setData((Object)messg);
					
					/*HERE ADD CHK TO SEE OF CLIENT IS CONNECTED..ELSE POP UPA MESG BOX ERROR*/
					Port theport = port[0];
					if(theport.connectionStatus == 0){
						System.out.println("\n Cant Send mssge the pclient is not connected");
						ErrorMessageBox emb = new ErrorMessageBox(dacia.Engine.graph,"Dis-Connected", "Client is not Connected on Port 0 ");

					}
					else{
						
						output(0,msg,Sync_Async);
					}
					
					
					
					
					Boolean n = new Boolean("false");
					return n.booleanValue();
		
		
					}
		
				else if(messg.equals("http://www.Load")){
		
				/* send the previous request's reply file */
		
					InputStream f;
					DataInputStream din;
 					
					try{

						f = new FileInputStream(new File("temp2"));//change to temp2 
						int len_file = f.available();
						byte[] buf = new byte[len_file];
						din = new DataInputStream(f);
						din.readFully(buf);
						String newbuf = new String(buf);
						
						
						
						
						int index_html1  = newbuf.indexOf("<html>");
						if(index_html1 == -1)
							index_html1 = newbuf.indexOf("<HTML>");

						int index_end1 = newbuf.indexOf("</html>");	
						if(index_end1 == -1)
							index_end1 = newbuf.indexOf("</HTML>");

						String new_one1 = newbuf.substring(index_html1,index_end1+7);
					
					
						//msg.setData((Object)new_one1);
						messg = new_one1;
						f.close();
			
			
 					}catch(Exception x){
							
							System.out.println("\n Exception in Filter Matched Function"+x);
						
							}
					
					msg.setData((Object)messg);
					
					
					/*HERE ADD CHK TO SEE OF CLIENT IS CONNECTED..ELSE POP UPA MESG BOX ERROR*/
					Port theport = port[0];
					if(theport.connectionStatus == 0){
						System.out.println("\n Cant Send mssge the pclient is not connected");
						ErrorMessageBox emb = new ErrorMessageBox(dacia.Engine.graph,"Dis-Connected", "Client is not Connected on Port 0 ");

					}
					else{
						
						output(0,msg,Sync_Async);
					}
					
					
					
					Boolean n = new Boolean("false");
					return n.booleanValue();
		
				
					}
					
				else if(messg.startsWith("http://EMAIL.")){
				
				/*get the email address of the client */
		
					String email_add = messg.substring("http://EMAIL.".length(),messg.length());
					mailTo = email_add;
					//System.out.println( "\n\n\n Email addr" + mailTo +"\n" + " messg" + messg + "\n\n");
					Boolean n = new Boolean("false");
					return n.booleanValue();
				
					}
		
				else if(messg.startsWith("http://CITY.")){
		
				/*get the city name */
		
					String city_add = messg.substring("http://CITY.".length(),messg.length());
					cityTo = city_add;
					//System.out.println( "\n\n\n City addr" + cityTo +"\n" + " messg" + messg + "\n\n");
					Boolean n = new Boolean("false");
					return n.booleanValue();
		
					}
					
				else if(messg.startsWith("http://TEMPCMP.")){
				
				/*get the temp to compare */
		
					if(temp2.exists())
						temp2.delete();
					temp2 = new File("temp2");
				
					String tmp_add = messg.substring("http://TEMPCMP.".length(),messg.length());
					tempcompare = new Integer(tmp_add).intValue();
					//System.out.println( "\n\n\n Tmp Add" + tempcompare +"\n" + " messg" + messg + "\n\n");
		
					//get the link for city's weather now and send mssg
					url_combo_selctn = "http://www.cnn.com/WEATHER/"+ map.get(cityTo);
					messg = url_combo_selctn;
	
					msg.setData((Object)messg);
					
					}
			
				else { 
		
				/*othr mssges..send them directly to the proxy server */
		
					if(temp2.exists())
						temp2.delete();
					temp2 = new File("temp2");
		
			
	    				 }
					 
      		}
		
		return s.booleanValue();
		/*if boolean value is true it sends mssges to proxy..this is wht is done for common http url's */
 }

/*end of filter */
}

/**
  * a class to create error message dialogs
  */
class ErrorMessageBox extends Dialog {

    String msg;  	 
/**
  * Constructor 
  */
    public ErrorMessageBox(Frame parent, String title, String msg) { 
		super(parent, title, true);  	  
		this.msg = msg;
		setFont(new Font("sanserif", Font.PLAIN, 12));
		setLayout(new BorderLayout()); 	  
		Panel p = new Panel();  	
		
		Button ok = new Button("OK"); 
		p.add(ok);
		add("South", p); 
		
		// Handle events on the buttons
		ActionListener buttonListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String label = ((Button)e.getSource()).getLabel(); 	
				if (label.equals("OK")) 
					dispose(); 
			}
		};
	 	
		ok.addActionListener(buttonListener);
		setSize(240, 120);
		setResizable(false); 
		show(); 	 
    }
 	
/**
  * Paint the Message on the Dialog
  */ 
	public void paint(Graphics g) { 
		g.drawString(msg, 10, 60);	 
	}

}







